'**************************************************************************
'	Core Winsock Development Systems Setup Script
'	Copyright Core Systems, 1994
'	Author: Linh Vuong
'**************************************************************************

'$DEFINE DEBUG  ''Define for script development/debugging

'$INCLUDE 'setupapi.inc'
'$INCLUDE 'msdetect.inc'

'$INCLUDE 'coreins.inc'

CONST SW_SHOWNORMAL = 1
DECLARE FUNCTION WinExec LIB "KERNEL.EXE" (cmd$, show%) AS INTEGER

''Dialog ID's
CONST ASKQUIT      = 200
CONST DESTPATH     = 300
CONST EXITFAILURE  = 400
CONST EXITQUIT     = 600
CONST EXITSUCCESS  = 700
CONST EXITSUCCESS1 = 750
CONST OPTIONS      = 800
CONST APPHELP      = 900
CONST CUSTINST     = 6201
CONST TOOBIG       = 6300
CONST BADPATH      = 6400

''Bitmap ID
CONST LOGO         = 1

''File Types
CONST OPTFILES1    = 1
CONST OPTFILES2    = 2
''CONST OPTFILES3    = 3
''CONST OPTFILES4    = 4
CONST NUMOPTIONS   = 2

GLOBAL OLDCOREDIR$
GLOBAL DEST$        ''Default destination directory.
GLOBAL WINDRIVE$    ''Windows drive letter.
GLOBAL OPT1OPT$     ''Option selection from OptFiles1 option dialog.
GLOBAL OPT2OPT$     ''Option selection from OptFiles2 option dialog.
''GLOBAL OPT3OPT$     ''Option selection from OptFiles3 option dialog.
''GLOBAL OPT4OPT$     ''Option selection from OptFiles4 option dialog.

''CustInst list symbol names
GLOBAL OPT1NEEDS$    ''Option list costs per drive
GLOBAL OPT2NEEDS$
''GLOBAL OPT3NEEDS$
''GLOBAL OPT4NEEDS$
GLOBAL EXTRACOSTS$  ''List of extra costs to add per drive
GLOBAL BIGLIST$     ''List of option files cost calc results (boolean)

''Dialog list symbol names
GLOBAL CHECKSTATES$
GLOBAL STATUSTEXT$
GLOBAL DRIVETEXT$

GLOBAL FrameWindow%

COREWSDS$ = "corewsds"
VXDWSA$ = "\vxdwsa.386"
ALLDRIVES$ = "AllLocalHardDrives"

DECLARE SUB AddOptFilesToCopyList (ftype%)
DECLARE SUB RecalcOptFiles (ftype%)
DECLARE SUB RecalcPath
DECLARE SUB SetDriveStatus
DECLARE FUNCTION MakePath (szDir$, szFile$) AS STRING

INIT:
    FrameWindow% = HwndFrame ()
    SetSymbolValue "FrameWindow", STR$ (FrameWindow%)
    ExpandWin(FrameWindow%)

    CUIDLL$ = "mscuistf.dll"            ''custom user interface dll
    HELPPROC$ = "FHelpDlgProc"          ''Help dialog procedure

    SetBitmap CUIDLL$, LOGO
    SetTitle "Core Winsock Development System Setup"

    szInf$ = GetSymbolValue("STF_SRCINFPATH")
    IF szInf$ = "" THEN
        szInf$ = GetSymbolValue("STF_CWDDIR") + COREWSDS$ + ".INF"
    END IF
    ReadInfFile szInf$

    WINDRIVE$ = MID$(GetWindowsDir, 1, 1)
    OLDCOREDIR$ = FindFileUsingFileOpen("wsacore.exe")
''    GetLocalHardDrivesList ALLDRIVES$
''    n% = GetListLength(ALLDRIVES$)
''    FOR i% = 1 TO n% STEP 1
''        d$ = GetListItem(ALLDRIVES$,i%)
''        IF d$ <> "" THEN
''            IF IsDriveLocalHard(d$) = 1 THEN
''                OLDCOREDIR$ = FindFileInTree("wsacore.exe",d$ + ":\")
''                IF OLDCOREDIR$ <> "" THEN
''                    GOTO FOUNDOLDCORE
''                END IF
''            END IF
''        END IF
''    NEXT i%
''FOUNDOLDCORE:
    IF OLDCOREDIR$ = "" THEN
        DEST$ = WINDRIVE$ + ":\" + COREWSDS$
    ELSE
        DEST$ = MID$(OLDCOREDIR$, 1, LEN(OLDCOREDIR$) - LEN("\wsacore.exe"))
    END IF

    ''CustInst list symbols
    CHECKSTATES$ = "CheckItemsState"
    STATUSTEXT$  = "StatusItemsText"
    DRIVETEXT$   = "DriveStatusText"
    FOR i% = 1 TO NUMOPTIONS STEP 1
        AddListItem CHECKSTATES$, "ON"
    NEXT i%
    FOR i% = 1 TO NUMOPTIONS STEP 1
        AddListItem STATUSTEXT$, ""
    NEXT i%
    FOR i% = 1 TO 7 STEP 1
        AddListItem DRIVETEXT$, ""
    NEXT i%
    ReplaceListItem DRIVETEXT$, 7, DEST$

    ''Disk cost list symbols
    OPT1NEEDS$  = "Opt1Needs"
    OPT2NEEDS$  = "Opt2Needs"
    ''OPT3NEEDS$  = "Opt3Needs"
    ''OPT4NEEDS$  = "Opt4Needs"
    EXTRACOSTS$ = "ExtraCosts"
    BIGLIST$    = "BigList"
    FOR i% = 1 TO NUMOPTIONS STEP 1
        AddListItem BIGLIST$, ""
    NEXT i%
    FOR i% = 1 TO 26 STEP 1
        AddListItem EXTRACOSTS$, "0"
    NEXT i%

    ''File Option Variables
    OPT1OPT$ = "1"
    OPT2OPT$ = "2"
    ''OPT3OPT$ = "3"
    ''OPT4OPT$ = "4"

    RecalcPath
    SetDriveStatus

'$IFDEF DEBUG
    i% = SetSizeCheckMode(scmOnIgnore)    '' could use scmOff; def = scmOnFatal
'$ENDIF ''DEBUG

CUSTINST:
    sz$ = UIStartDlg(CUIDLL$, CUSTINST, "FCustInstDlgProc", APPHELP, HELPPROC$)

    IF sz$ = "CONTINUE" THEN
        ''Install only if it will fit.
        FOR i% = 1 TO NUMOPTIONS STEP 1
            IF GetListItem(BIGLIST$, i%) <> "" THEN
                GOSUB TOOBIG
                GOTO CUSTINST
            END IF
        NEXT i%
        UIPop 1
        GOTO INSTALL
    ELSEIF sz$ = "PATH" THEN
        GOTO GETPATH
    ELSEIF sz$ = "CHK1" THEN
        RecalcOptFiles OPTFILES1
        SetDriveStatus
        GOTO CUSTINST
    ELSEIF sz$ = "CHK2" THEN
        RecalcOptFiles OPTFILES2
        SetDriveStatus
        GOTO CUSTINST
''    ELSEIF sz$ = "CHK3" THEN
''        RecalcOptFiles OPTFILES3
''        SetDriveStatus
''        GOTO CUSTINST
''    ELSEIF sz$ = "CHK4" THEN
''        RecalcOptFiles OPTFILES4
''        SetDriveStatus
''        GOTO CUSTINST
    ELSEIF sz$ = "BTN1" THEN
        GOTO OPTFILES1
    ELSEIF sz$ = "BTN2" THEN
        GOTO OPTFILES2
''    ELSEIF sz$ = "BTN3" THEN
''        GOTO OPTFILES3
''    ELSEIF sz$ = "BTN4" THEN
''        GOTO OPTFILES4
    ELSEIF sz$ = "REACTIVATE" THEN
        RecalcPath
        SetDriveStatus
        GOTO CUSTINST
    ELSE
        GOSUB ASKQUIT
        GOTO CUSTINST
    END IF

INSTALL:
    ClearCopyList
    AddOptFilesToCopyList OPTFILES1
    AddOptFilesToCopyList OPTFILES2
''    AddOptFilesToCopyList OPTFILES3
''    AddOptFilesToCopyList OPTFILES4
    CreateDir DEST$, cmoNone
    CopyFilesInCopyList

    IF GetListItem(CHECKSTATES$, OPTFILES1) = "ON" THEN
	i% = ProbeVxd()
	IF i% = 0 THEN
    	   vxd$ = DEST$ + VXDWSA$
	   ini$ = MakePath(GetWindowsDir, "SYSTEM.INI")
	   CreateSysIniKeyValue ini$, "386Enh", "Device", vxd$, cmoVital
           ini$ = ""
	END IF
        CreateProgmanGroup "Core Winsock SDK", "", cmoNone
        ShowProgmanGroup  "Core Winsock SDK", 1, cmoNone
        CreateProgmanItem "Core Winsock SDK", "Winsock API", "winhelp.exe "+MakePath(DEST$,"winsock.hlp"), "", cmoOverwrite
        CreateProgmanItem "Core Winsock SDK", "Problem Report", MakePath(DEST$,"problem.wri"), "", cmoOverwrite
        CreateProgmanItem "Core Winsock SDK", "Read Me", MakePath(DEST$,"relnotes.wri"), "", cmoOverwrite
        CreateProgmanItem "Core Winsock SDK", "core.ini", MakePath(DEST$,"core.ini"), "", cmoOverwrite
    END IF

    IF GetListItem(CHECKSTATES$, OPTFILES2) = "ON" THEN
        ShowProgmanGroup  "Core Winsock SDK", 1, cmoNone
        CreateProgmanItem "Core Winsock SDK", "wsacore", MakePath(DEST$,"wsacore.exe"), "", cmoOverwrite
        CreateProgmanItem "Core Winsock SDK", "wsaspy", MakePath(DEST$,"wsaspy.exe"), "", cmoOverwrite
        CreateProgmanItem "Core Winsock SDK", "wsaconf", MakePath(DEST$,"wsaconf.exe"), "", cmoOverwrite
        CreateProgmanItem "Core Winsock SDK", "wping", MakePath(DEST$,"wping.exe"), "", cmoOverwrite
        CreateProgmanItem "Core Winsock SDK", "wfinger", MakePath(DEST$,"wfinger.exe"), "", cmoOverwrite
    END IF

QUIT:
    ON ERROR GOTO ERRQUIT

    IF ERR = 0 THEN
        dlg% = EXITSUCCESS1
    ELSEIF ERR = STFQUIT THEN
        dlg% = EXITQUIT
    ELSE
        dlg% = EXITFAILURE
    END IF
QUITL1:
    sz$ = UIStartDlg(CUIDLL$, dlg%, "FInfo0DlgProc", 0, "")
    IF sz$ = "REACTIVATE" THEN
        GOTO QUITL1
    END IF
    IF (dlg% = EXITSUCCESS1) AND (sz$ = "CONTINUE") THEN
        i% = WinExecAndWait(0, "write.exe " + MakePath(DEST$,"relnotes.wri"), SW_SHOWNORMAL)
        ''i% = WinExecAndWait(FrameWindow%, "write.exe " + MakePath(DEST$,"relnotes.wri"), SW_SHOWNORMAL)
        ''i% = WinExec("write.exe " + MakePath(DEST$,"relnotes.wri"), SW_SHOWNORMAL)
    END IF
    i% = DoMsgBox("Would you like to configure Core Winsock now ?", "Core Winsock Setup", MB_YESNO+MB_TASKMODAL+MB_ICONINFORMATION)
    IF (i% = IDYES) THEN
        i% = WinExecAndWait(0, MakePath(DEST$,"wsaconf.exe"), SW_SHOWNORMAL)
        ''i% = WinExecAndWait(FrameWindow%, MakePath(DEST$,"wsaconf.exe"), SW_SHOWNORMAL)
        ''i% = WinExec(MakePath(DEST$,"wsaconf.exe"), SW_SHOWNORMAL)
    END IF
    UIPop 1

    END

ERRQUIT:
    i% = DoMsgBox("Setup sources were corrupted, contact Core Systems Product Support !", "Setup Message", MB_OK+MB_TASKMODAL+MB_ICONHAND)
    END

GETPATH:
    SetSymbolValue "EditTextIn", DEST$
    SetSymbolValue "EditFocus", "END"
GETPATHL1:
    sz$ = UIStartDlg(CUIDLL$, DESTPATH, "FEditDlgProc", APPHELP, HELPPROC$)

    IF sz$ = "CONTINUE" THEN
        olddest$ = DEST$
        DEST$ = GetSymbolValue("EditTextOut")

        ''Validate new path.
        IF IsDirWritable(DEST$) = 0 THEN
            GOSUB BADPATH
            GOTO GETPATHL1
        END IF
        UIPop 1

        ''Truncate display if too long.
        IF LEN(DEST$) > 23 THEN
            ReplaceListItem DRIVETEXT$, 7, MID$(DEST$, 1, 23)+"..."
        ELSE
            ReplaceListItem DRIVETEXT$, 7, DEST$
        END IF

        ''Recalc if path changed.
        IF (olddest$ <> DEST$) AND (olddest$ <> DEST$+"\") AND (olddest$+"\" <> DEST$) THEN
            RecalcPath
            SetDriveStatus
        END IF

        olddest$ = ""
        GOTO CUSTINST
    ELSEIF sz$ = "REACTIVATE" THEN
        RecalcPath
        SetDriveStatus
        GOTO GETPATHL1
    ELSEIF sz$ = "EXIT" THEN
        GOSUB ASKQUIT
        GOTO GETPATHL1
    ELSE
        UIPop 1
        GOTO CUSTINST
    END IF


OPTFILES1:
    newopt$ = GetListItem(CHECKSTATES$, OPTFILES1)
	IF newopt$ = "ON" THEN
        	RecalcPath
		RecalcOptFiles OPTFILES1
		SetDriveStatus
	END IF
	newopt$ = ""
	GOTO CUSTINST

OPTFILES2:
    newopt$ = GetListItem(CHECKSTATES$, OPTFILES2)
	IF newopt$ = "ON" THEN
        	RecalcPath
		RecalcOptFiles OPTFILES2
		SetDriveStatus
	END IF
	newopt$ = ""
	GOTO CUSTINST

''OPTFILES3:
''    newopt$ = GetListItem(CHECKSTATES$, OPTFILES3)
''	IF newopt$ = "ON" THEN
''       	RecalcPath
''		RecalcOptFiles OPTFILES3
''		SetDriveStatus
''	END IF
''	newopt$ = ""
''	GOTO CUSTINST

''OPTFILES4:
''    newopt$ = GetListItem(CHECKSTATES$, OPTFILES4)
''	IF newopt$ = "ON" THEN
''        	RecalcPath
''		RecalcOptFiles OPTFILES4
''		SetDriveStatus
''	END IF
''	newopt$ = ""
''	GOTO CUSTINST

TOOBIG:
    sz$ = UIStartDlg(CUIDLL$, TOOBIG, "FInfo0DlgProc", 0, "")
    IF sz$ = "REACTIVATE" THEN
        RecalcPath
        SetDriveStatus
        GOTO TOOBIG
    END IF
    UIPop 1
    RETURN

BADPATH:
    sz$ = UIStartDlg(CUIDLL$, BADPATH, "FInfo0DlgProc", 0, "")
    IF sz$ = "REACTIVATE" THEN
        RecalcPath
        SetDriveStatus
        GOTO BADPATH
    END IF
    UIPop 1
    RETURN

ASKQUIT:
    sz$ = UIStartDlg(CUIDLL$, ASKQUIT, "FQuitDlgProc", 0, "")

    IF sz$ = "EXIT" THEN
        UIPopAll
        ERROR STFQUIT
    ELSEIF sz$ = "REACTIVATE" THEN
        GOTO ASKQUIT
    ELSE
        UIPop 1
    END IF
    RETURN



'**
'** Purpose:
'**     Adds the specified option files to the copy list.
'** Arguments:
'**     ftype%  - type of files to add, one of the following:
'**             OPTFILES1, OPTFILES2, OPTFILES3, OPTFILES4
'** Returns:
'**     none.
'*************************************************************************
SUB AddOptFilesToCopyList (ftype%) STATIC

    IF GetListItem(CHECKSTATES$, ftype%) = "ON" THEN
        SrcDir$ = GetSymbolValue("STF_SRCDIR")
        IF ftype% = OPTFILES1 THEN
            AddSectionKeyFileToCopyList "Optfiles1", OPT1OPT$, SrcDir$, DEST$
        ELSEIF ftype% = OPTFILES2 THEN
            AddSectionKeyFileToCopyList "Optfiles2", OPT2OPT$, SrcDir$, DEST$
''        ELSEIF ftype% = OPTFILES3 THEN
''            AddSectionKeyFileToCopyList "Optfiles3", OPT3OPT$, SrcDir$, DEST$
''        ELSEIF ftype% = OPTFILES4 THEN
''            AddSectionKeyFileToCopyList "Optfiles4", OPT4OPT$, SrcDir$, DEST$
        END IF
        SrcDir$ = ""
    END IF
END SUB


'**
'** Purpose:
'**     Recalculates disk space for the given option files and sets
'**     the status info symbol "StatusItemsText".
'** Arguments:
'**     ftype% - type of files to add, one of the following:
'**             OPTFILES1, OPTFILES2, OPTFILES3, OPTFILES4
'** Returns:
'**     none.
'*************************************************************************
SUB RecalcOptFiles (ftype%) STATIC
    CursorSave% = ShowWaitCursor()
    ClearCopyList
    AddOptFilesToCopyList ftype%

    fExtra% = 0
    IF ftype% = OPTFILES1 THEN
        ListSym$ = OPT1NEEDS$
    ELSEIF ftype% = OPTFILES2 THEN
        ListSym$ = OPT2NEEDS$
''    ELSEIF ftype% = OPTFILES3 THEN
''        ListSym$ = OPT3NEEDS$
''    ELSEIF ftype% = OPTFILES4 THEN
''        ListSym$ = OPT4NEEDS$
    END IF

    StillNeed& = GetCopyListCost(EXTRACOSTS$, ListSym$, "")

    cost& = 0
    FOR i% = 1 TO 26 STEP 1
        cost&  = cost& + VAL(GetListItem(ListSym$, i%))
    NEXT i%
    ReplaceListItem STATUSTEXT$, ftype%, STR$(cost& / 1024) + " K"

    IF StillNeed& > 0 THEN
        ReplaceListItem BIGLIST$, ftype%, "YES"
    ELSE
        ReplaceListItem BIGLIST$, ftype%, ""
    END IF

    IF fExtra% THEN
        ReplaceListItem EXTRACOSTS$, ndrive%, "0"
    END IF
    RestoreCursor CursorSave%
    ListSym$ = ""
END SUB


'**
'** Purpose:
'**     Recalculates disk space and sets option status info according
'**     to the current destination path.
'** Arguments:
'**     none.
'** Returns:
'**     none.
'*************************************************************************
SUB RecalcPath STATIC

    CursorSave% = ShowWaitCursor()

    RecalcOptFiles OPTFILES1
    RecalcOptFiles OPTFILES2
''    RecalcOptFiles OPTFILES3
''    RecalcOptFiles OPTFILES4

    RestoreCursor CursorSave%
END SUB


'**
'** Purpose:
'**     Sets drive status info according to latest disk space calcs.
'** Arguments:
'**     none.
'** Returns:
'**     none.
'*************************************************************************
SUB SetDriveStatus STATIC

    drive$ = MID$(DEST$, 1, 1)
    ndrive% = ASC(ucase$(drive$)) - ASC("A") + 1
''    cost& = VAL(GetListItem(OPT1NEEDS$, ndrive%)) + VAL(GetListItem(OPT2NEEDS$, ndrive%)) + VAL(GetListItem(OPT3NEEDS$, ndrive%)) + VAL(GetListItem(OPT4NEEDS$, ndrive%))
    cost& = VAL(GetListItem(OPT1NEEDS$, ndrive%)) + VAL(GetListItem(OPT2NEEDS$, ndrive%))
    free& = GetFreeSpaceForDrive(drive$)
    ReplaceListItem DRIVETEXT$, 1, drive$ + ":"
    ReplaceListItem DRIVETEXT$, 2, STR$(cost& / 1024) + " K"
    ReplaceListItem DRIVETEXT$, 3, STR$(free& / 1024) + " K"

    IF drive$ = WINDRIVE$ THEN
        ReplaceListItem DRIVETEXT$, 4, ""
        ReplaceListItem DRIVETEXT$, 5, ""
        ReplaceListItem DRIVETEXT$, 6, ""
    ELSE
        ndrive% = ASC(ucase$(WINDRIVE$)) - ASC("A") + 1
''        cost& = VAL(GetListItem(OPT1NEEDS$, ndrive%)) + VAL(GetListItem(OPT2NEEDS$, ndrive%)) + VAL(GetListItem(OPT3NEEDS$, ndrive%)) + VAL(GetListItem(OPT4NEEDS$, ndrive%))
        cost& = VAL(GetListItem(OPT1NEEDS$, ndrive%)) + VAL(GetListItem(OPT2NEEDS$, ndrive%))
        IF cost& = 0 THEN
            ReplaceListItem DRIVETEXT$, 4, ""
            ReplaceListItem DRIVETEXT$, 5, ""
            ReplaceListItem DRIVETEXT$, 6, ""
        ELSE
            free& = GetFreeSpaceForDrive(WINDRIVE$)
            ReplaceListItem DRIVETEXT$, 4, WINDRIVE$ + ":"
            ReplaceListItem DRIVETEXT$, 5, STR$(cost& / 1024) + " K"
            ReplaceListItem DRIVETEXT$, 6, STR$(free& / 1024) + " K"
        END IF
    END IF
END SUB


'**
'** Purpose:
'**     Appends a file name to the end of a directory path,
'**     inserting a backslash character as needed.
'** Arguments:
'**     szDir$  - full directory path (with optional ending "\")
'**     szFile$ - filename to append to directory
'** Returns:
'**     Resulting fully qualified path name.
'*************************************************************************
FUNCTION MakePath (szDir$, szFile$) STATIC AS STRING
    IF szDir$ = "" THEN
        MakePath = szFile$
    ELSEIF szFile$ = "" THEN
        MakePath = szDir$
    ELSEIF MID$(szDir$, LEN(szDir$), 1) = "\" THEN
        MakePath = szDir$ + szFile$
    ELSE
        MakePath = szDir$ + "\" + szFile$
    END IF
END FUNCTION

